import { Observable } from 'rxjs';
import { _NgScrollbar } from '../utils/scrollbar-base';
import { ThumbAdapter } from '../thumb/thumb-adapter';
import * as i0 from "@angular/core";
export declare abstract class TrackAdapter {
    readonly nativeElement: HTMLElement;
    protected readonly cmp: _NgScrollbar;
    private readonly document;
    private readonly zone;
    private sizeChangeSub;
    private currMousePosition;
    private scrollDirection;
    private scrollMax;
    protected abstract readonly clientProperty: 'clientX' | 'clientY';
    protected abstract readonly cssLengthProperty: string;
    protected abstract get viewportScrollSize(): number;
    protected abstract get viewportSize(): number;
    protected abstract get viewportScrollOffset(): number;
    abstract get size(): number;
    abstract get offset(): number;
    protected abstract scrollTo(position: number): Observable<void>;
    protected abstract getScrollDirection(position: number): 'forward' | 'backward';
    get clientRect(): DOMRect;
    protected thumb: ThumbAdapter;
    get dragged(): Observable<any>;
    constructor();
    private updateCSSVariables;
    /**
     *  Callback when mouse is first clicked on the track
     */
    onTrackFirstClick(e: PointerEvent): Observable<boolean>;
    /**
     * Callback when mouse is still down on the track
     * Incrementally scrolls towards target position until reached
     */
    onTrackOngoingMousedown(): Observable<boolean>;
    /**
     *  Returns the normalized position whether it's forward or backward for both LTR or RTL directions
     */
    private getCurrPosition;
    /**
     * Returns a flag that determines whether the scroll from the given position is the final step or not
     */
    private isFinalStep;
    static ɵfac: i0.ɵɵFactoryDeclaration<TrackAdapter, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TrackAdapter, never, never, {}, {}, ["thumb"], never, false, never>;
}
